﻿#region copyright
// SabberStone, Hearthstone Simulator in C# .NET Core
// Copyright (C) 2017-2019 SabberStone Team, darkfriend77 & rnilva
//
// SabberStone is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as
// published by the Free Software Foundation, either version 3 of the
// License.
// SabberStone is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
#endregion
using System;
using System.Collections.Generic;
using System.Linq;
using SabberStoneCore.Model.Entities;
using SabberStoneCoreAi.src.Agent;
using SabberStoneCoreAi.Competition.Agents;


namespace SabberStoneCoreAi.Score
{
	public class ScoreMage : Score
	{
		public override int Rate()
		{
			
			POGame.POGame old = cState.getState();
			Controller pC = old.CurrentPlayer.Controller;
			Controller oC = pC.Opponent;

			if (OpHeroHp < 1)
				return Int32.MaxValue;

			if (HeroHp < 1)
				return Int32.MinValue;

			int result = 0;

			result += (MinionTotHealthTaunt - OpMinionTotHealthTaunt) * 25;

			result += MinionTotAtk * 10;

			if((Controller.RemainingMana - pC.RemainingMana) > 0)
			result += (Controller.RemainingMana - pC.RemainingMana) * 10;
			
			if((MinionTotHealth - pC.BoardZone.Sum(p => p.Health)) > 0)
			result += (MinionTotHealth - pC.BoardZone.Sum(p => p.Health)) * 20;

			result += (oC.BoardZone.Count - Controller.Opponent.BoardZone.Count - (pC.BoardZone.Count - Controller.BoardZone.Count)) * 50;

			result += (oC.Hero.Health - OpHeroHp) * 40;

			result -= (pC.Hero.Health - HeroHp) * 20;

			result += (oC.BoardZone.Where(p => p.HasWindfury).Sum(p => p.Health) - OpBoardZone.Where(p => p.HasWindfury).Sum(p => p.Health)) * 1000;

			return result;
		}

		public override Func<List<IPlayable>, List<int>> MulliganRule()
		{
			return p => p.Where(t => t.Cost > 3).Select(t => t.Id).ToList();
		}
	}
}
